/* ====================================================================
 * SDSC Matrix Software License, Version 1.0
 *
 * Copyright (c) 2003 San Diego Supercomputer Center (SDSC), San Diego, USA.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that ALL the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        SDSC Matrix Project (http://www.npaci.edu/DICE/SRB/matrix/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "SDSC" and "SDSC Matrix" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact arun@sdsc.edu or srb-chat@sdsc.edu.
 *
 * 5. Products derived from this software may not be called "SDSC",
 *    nor may "SDSC" appear in their name, without prior written
 *    permission of the SDSC.
 *
 * 6. License is not granted for commercial resale, in whole or in part, 
 *	  without the prior written permission from SDSC.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL SDSC OR
 * ITS CONTRIBUTORS (SDSC Matrix Team) BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software is intended to consist of voluntary contributions made by many
 * individuals for the SDSC Matrix Project.
 *
 * SDSC Matrix.  
 * Designer & Architect: Arun swaran Jagatheesan (arun@sdsc.edu)
 *
 * Authors (Credits 02/SEP/2003):
 * Allen Ding (alding@sdsc.edu)
 * Arun Jagatheesan (arun@sdsc.edu)
 * Reena Mathew	(rmathew@sdsc.edu)
 * Erik Vandekieft (evk@sdsc.edu)
 */



package edu.sdsc.matrix.srb.core;

/**
 * Class contains the codes used by the Matrix Application Server
 * Codes are used to indicate<br>
 * - Transaction Status<br>
 * - Flow Status<br>
 * - Step Status<br>
 *   
 * @author rmathew
 */
public class MatrixCodes 
{
	
	public static final int STEP_NOT_FOUND_OR_NOT_STARTED = 9000001;
	public static final int TRANSACTION_NOT_FOUND_OR_NOT_STARTED = 9000002;
    public static final int STEP_STARTED = 9000003;
    public static final int STEP_COMPLETE =9000004;
	public static final int STEP_ABORTED_DUE_TO_ERROR =9000005;
	
	// Added on 19 June 2003 by Reena
	// To check if transaction,flow or step has been requested to be aborted
	public static final int TRANSACTION_ABORTED_DUE_TO_REQUEST_FROM_USER =9000006;
	public static final int FLOW_ABORTED_DUE_TO_REQUEST_FROM_USER =9000007;
	public static final int STEP_ABORTED_DUE_TO_REQUEST_FROM_USER =9000008;
	
	public static final int TRANSACTION_STARTED =9000009;
	public static final int FLOW_STARTED =9000010;
	
	public static final int TRANSACTION_COMPLETE =9000011;
	public static final int FLOW_COMPLETE =9000012;
	
	public static final int TRANSACTION_ABORTED_DUE_TO_ERROR =9000013;
	public static final int FLOW_ABORTED_DUE_TO_ERROR =9000014;
	
	public static final int FLOW_NOT_FOUND_OR_NOT_STARTED =9000015;
	
	// Different Types of Grid
	/**
	 * SRB Grid Type
	 */
	public static final String SRB_GRID = "SRB";

}
