/* ====================================================================
 * SDSC Matrix Software License, Version 1.0
 *
 * Copyright (c) 2003 San Diego Supercomputer Center (SDSC), San Diego, USA.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that ALL the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        SDSC Matrix Project (http://www.npaci.edu/DICE/SRB/matrix/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "SDSC" and "SDSC Matrix" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact arun@sdsc.edu or srb-chat@sdsc.edu.
 *
 * 5. Products derived from this software may not be called "SDSC",
 *    nor may "SDSC" appear in their name, without prior written
 *    permission of the SDSC.
 *
 * 6. License is not granted for commercial resale, in whole or in part, 
 *	  without the prior written permission from SDSC.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL SDSC OR
 * ITS CONTRIBUTORS (SDSC Matrix Team) BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software is intended to consist of voluntary contributions made by many
 * individuals for the SDSC Matrix Project.
 *
 * SDSC Matrix.  
 * Designer & Architect: Arun swaran Jagatheesan (arun@sdsc.edu)
 *
 * Authors (Credits 02/SEP/2003):
 * Allen Ding (alding@sdsc.edu)
 * Arun Jagatheesan (arun@sdsc.edu)
 * Reena Mathew	(rmathew@sdsc.edu)
 * Erik Vandekieft (evk@sdsc.edu)
 */



package edu.sdsc.matrix.srb.util;

import edu.sdsc.grid.io.srb.SRBMetaDataSet;


public class SRBMetaDataFieldMappings
{
	/*
		 * Contains the mappings of the Matrix Metadata fields to JARGON Metadata fields
		 * These fields obtained from SRBMetaDataTest.java from jargon code
		 */	
		private static String [][] srbVariableMapping = 
							{
								{"OFFSET",SRBMetaDataSet.OFFSET},
								{"SIZE",SRBMetaDataSet.SIZE},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"USER_TYPE_NAME",SRBMetaDataSet.USER_TYPE_NAME},
								{"USER_NAME",SRBMetaDataSet.USER_NAME},
								{"USER_GROUP_NAME",SRBMetaDataSet.USER_GROUP_NAME},
								{"USER_ADDRESS",SRBMetaDataSet.USER_ADDRESS},
								{"ACCESS_CONSTRAINT",SRBMetaDataSet.ACCESS_CONSTRAINT},
								{"FILE_NAME",SRBMetaDataSet.FILE_NAME},
							
								{"FILE_ID",SRBMetaDataSet.FILE_ID},
								{"FILE_REPLICATION_ENUM",SRBMetaDataSet.FILE_REPLICATION_ENUM},
								{"FILE_NAME",SRBMetaDataSet.FILE_NAME},
								{"USER_GROUP_NAME",SRBMetaDataSet.USER_GROUP_NAME},
								{"FILE_TYPE_NAME",SRBMetaDataSet.FILE_TYPE_NAME},
								{"USER_TYPE_NAME",SRBMetaDataSet.USER_TYPE_NAME},
								{"USER_ADDRESS",SRBMetaDataSet.USER_ADDRESS},
								{"USER_NAME",SRBMetaDataSet.USER_NAME},
								{"ACCESS_CONSTRAINT",SRBMetaDataSet.ACCESS_CONSTRAINT},
								{"USER_DOMAIN",SRBMetaDataSet.USER_DOMAIN},
								{"PATH_NAME",SRBMetaDataSet.PATH_NAME},
								{"RESOURCE_NAME",SRBMetaDataSet.RESOURCE_NAME},
								{"RESOURCE_ADDRESS_NETPREFIX",SRBMetaDataSet.RESOURCE_ADDRESS_NETPREFIX},
								{"RESOURCE_TYPE_NAME",SRBMetaDataSet.RESOURCE_TYPE_NAME},
								{"MODIFICATION_DATE",SRBMetaDataSet.MODIFICATION_DATE},
								{"DIRECTORY_NAME",SRBMetaDataSet.DIRECTORY_NAME},
								{"USER_PHONE",SRBMetaDataSet.USER_PHONE},
								{"USER_EMAIL",SRBMetaDataSet.USER_EMAIL},
								{"SIZE",SRBMetaDataSet.SIZE},
								{"USER_AUDIT_TIME_STAMP",SRBMetaDataSet.USER_AUDIT_TIME_STAMP},
								{"USER_AUDIT_COMMENTS",SRBMetaDataSet.USER_AUDIT_COMMENTS},
								{"FILE_COMMENTS",SRBMetaDataSet.FILE_COMMENTS},
								{"AUDIT_ACTION_DESCRIPTION",SRBMetaDataSet.AUDIT_ACTION_DESCRIPTION},
								{"AUDIT_TIMESTAMP",SRBMetaDataSet.AUDIT_TIMESTAMP},
								{"AUDIT_COMMENTS",SRBMetaDataSet.AUDIT_COMMENTS},
								//{"GROUP_ACCESS_CONSTRAINT",SRBMetaDataSet.GROUP_ACCESS_CONSTRAINT},
								//{"ACCESS_GROUP_NAME",SRBMetaDataSet.ACCESS_GROUP_NAME},
								{"RESOURCE_DEFAULT_PATH",SRBMetaDataSet.RESOURCE_DEFAULT_PATH},
								{"PHYSICAL_RESOURCE_DEFAULT_PATH",SRBMetaDataSet.PHYSICAL_RESOURCE_DEFAULT_PATH},
								{"PHYSICAL_RESOURCE_NAME",SRBMetaDataSet.PHYSICAL_RESOURCE_NAME},
								{"PHYSICAL_RESOURCE_TYPE_NAME",SRBMetaDataSet.PHYSICAL_RESOURCE_TYPE_NAME},
								{"RESOURCE_REPLICATION_ENUM",SRBMetaDataSet.RESOURCE_REPLICATION_ENUM},
								{"FILE_ACCESS_LIST",SRBMetaDataSet.FILE_ACCESS_LIST},
								{"RESOURCE_ACCESS_LIST",SRBMetaDataSet.RESOURCE_ACCESS_LIST},
								{"FILE_IS_DELETED",SRBMetaDataSet.FILE_IS_DELETED},
								{"OWNER",SRBMetaDataSet.OWNER},
								{"TICKET_D",SRBMetaDataSet.TICKET_D},
								{"TICKET_BEGIN_TIME_D",SRBMetaDataSet.TICKET_BEGIN_TIME_D},
								{"TICKET_END_TIME_D",SRBMetaDataSet.TICKET_END_TIME_D},
								{"TICKET_ACC_COUNT_D",SRBMetaDataSet.TICKET_ACC_COUNT_D},
								{"TICKET_ACC_LIST_D",SRBMetaDataSet.TICKET_ACC_LIST_D},
								{"TICKET_OWNER_D",SRBMetaDataSet.TICKET_OWNER_D},
								{"TICKET_USER_D",SRBMetaDataSet.TICKET_USER_D},
								{"TICKET_C",SRBMetaDataSet.TICKET_C},
								{"TICKET_BEGIN_TIME_C",SRBMetaDataSet.TICKET_BEGIN_TIME_C},
								{"TICKET_END_TIME_C",SRBMetaDataSet.TICKET_END_TIME_C},
								{"TICKET_ACC_COUNT_C",SRBMetaDataSet.TICKET_ACC_COUNT_C},
								{"TICKET_ACC_LIST_C",SRBMetaDataSet.TICKET_ACC_LIST_C},
								{"TICKET_OWNER_C",SRBMetaDataSet.TICKET_OWNER_C},
								{"TICKET_USER_C",SRBMetaDataSet.TICKET_USER_C},
								{"TICKET_USER_DOMAIN_C",SRBMetaDataSet.TICKET_USER_DOMAIN_C},
								{"TICKET_USER_DOMAIN_D",SRBMetaDataSet.TICKET_USER_DOMAIN_D},
								{"TICKET_OWNER_DOMAIN_C",SRBMetaDataSet.TICKET_OWNER_DOMAIN_C},
								{"TICKET_OWNER_DOMAIN_D",SRBMetaDataSet.TICKET_OWNER_DOMAIN_D},
								{"PARENT_DIRECTORY_NAME",SRBMetaDataSet.PARENT_DIRECTORY_NAME},
								{"LOCATION_NAME",SRBMetaDataSet.LOCATION_NAME},
								{"IS_DIRTY",SRBMetaDataSet.IS_DIRTY},
								{"CONTAINER_MAX_SIZE",SRBMetaDataSet.CONTAINER_MAX_SIZE},
								{"CONTAINER_NAME",SRBMetaDataSet.CONTAINER_NAME},
								{"RESOURCE_CLASS",SRBMetaDataSet.RESOURCE_CLASS},
								{"MAX_OBJ_SIZE",SRBMetaDataSet.MAX_OBJ_SIZE},
								{"OFFSET",SRBMetaDataSet.OFFSET},
								{"CONTAINER_RESOURCE_NAME",SRBMetaDataSet.CONTAINER_RESOURCE_NAME},
								{"CONTAINER_RESOURCE_CLASS",SRBMetaDataSet.CONTAINER_RESOURCE_CLASS},
								{"CONTAINER_SIZE",SRBMetaDataSet.CONTAINER_SIZE},
								{"CONTAINER_LOG_RESOURCE_NAME",SRBMetaDataSet.CONTAINER_LOG_RESOURCE_NAME},
								{"OWNER_DOMAIN",SRBMetaDataSet.OWNER_DOMAIN},
								{"USER_DISTINGUISHED_NAME",SRBMetaDataSet.USER_DISTINGUISHED_NAME},
								{"USER_AUTHENTICATION_SCHEME",SRBMetaDataSet.USER_AUTHENTICATION_SCHEME},
								{"SERVER_LOCATION",SRBMetaDataSet.SERVER_LOCATION},
								{"SERVER_NETPREFIX",SRBMetaDataSet.SERVER_NETPREFIX},
								{"CONTAINER_REPLICATION_ENUM",SRBMetaDataSet.CONTAINER_REPLICATION_ENUM},
								{"FILE_ANNOTATION_USERNAME",SRBMetaDataSet.FILE_ANNOTATION_USERNAME},
								{"FILE_ANNOTATION_USERDOMAIN",SRBMetaDataSet.FILE_ANNOTATION_USERDOMAIN},
								{"FILE_ANNOTATION",SRBMetaDataSet.FILE_ANNOTATION},
								{"FILE_ANNOTATION_TIMESTAMP",SRBMetaDataSet.FILE_ANNOTATION_TIMESTAMP},
								{"CREATION_DATE",SRBMetaDataSet.CREATION_DATE},
								{"FILE_COMMENTS_TIMESTAMP",SRBMetaDataSet.FILE_COMMENTS_TIMESTAMP},
								{"FILE_ANNOTATION_POSITION",SRBMetaDataSet.FILE_ANNOTATION_POSITION},
								{"FILE_ACCESS_PRIVILEGE",SRBMetaDataSet.FILE_ACCESS_PRIVILEGE},
								{"RESOURCE_MAX_LATENCY",SRBMetaDataSet.RESOURCE_MAX_LATENCY},
								{"RESOURCE_MIN_LATENCY",SRBMetaDataSet.RESOURCE_MIN_LATENCY},
								{"RESOURCE_BANDWIDTH",SRBMetaDataSet.RESOURCE_BANDWIDTH},
								{"RESOURCE_MAX_CONCURRENCY",SRBMetaDataSet.RESOURCE_MAX_CONCURRENCY},
								{"RESOURCE_NUM_OF_HIERARCHIES",SRBMetaDataSet.RESOURCE_NUM_OF_HIERARCHIES},
								{"RESOURCE_NUM_OF_STRIPES",SRBMetaDataSet.RESOURCE_NUM_OF_STRIPES},
								{"RESOURCE_CAPACITY",SRBMetaDataSet.RESOURCE_CAPACITY},
								{"RESOURCE_DESCRIPTION",SRBMetaDataSet.RESOURCE_DESCRIPTION},
								{"FILE_CLASS_NAME",SRBMetaDataSet.FILE_CLASS_NAME},
								{"FILE_CLASS_TYPE",SRBMetaDataSet.FILE_CLASS_TYPE},
								{"STRUCTURED_METADATA_TYPE",SRBMetaDataSet.STRUCTURED_METADATA_TYPE},
								{"STRUCTURED_METADATA_COMMENTS",SRBMetaDataSet.STRUCTURED_METADATA_COMMENTS},
								{"STRUCTURED_METADATA_FILE_NAME",SRBMetaDataSet.STRUCTURED_METADATA_FILE_NAME},
								{"INTERNAL_STRUCTURED_METADATA",SRBMetaDataSet.INTERNAL_STRUCTURED_METADATA},
								{"INDEX_NAME_FOR_FILE",SRBMetaDataSet.INDEX_NAME_FOR_FILE},
								{"INDEX_NAME_FOR_DATATYPE",SRBMetaDataSet.INDEX_NAME_FOR_DATATYPE},
								{"INDEX_NAME_FOR_DIRECTORY",SRBMetaDataSet.INDEX_NAME_FOR_DIRECTORY},
								{"METHOD_NAME_FOR_FILE",SRBMetaDataSet.METHOD_NAME_FOR_FILE},
								{"METHOD_NAME_FOR_DATATYPE",SRBMetaDataSet.METHOD_NAME_FOR_DATATYPE},
								{"METHOD_NAME_FOR_DIRECTORY",SRBMetaDataSet.METHOD_NAME_FOR_DIRECTORY},
								{"IX_DIRECTORY_NAME_FOR_FILE",SRBMetaDataSet.IX_DIRECTORY_NAME_FOR_FILE},
								{"IX_DIRECTORY_NAME_FOR_DATATYPE",SRBMetaDataSet.IX_DIRECTORY_NAME_FOR_DATATYPE},
								{"IX_DIRECTORY_NAME_FOR_DIRECTORY",SRBMetaDataSet.IX_DIRECTORY_NAME_FOR_DIRECTORY},
								{"METHOD_DIRECTORY_NAME_FOR_FILE",SRBMetaDataSet.METHOD_DIRECTORY_NAME_FOR_FILE},
								{"METHOD_DIRECTORY_NAME_FOR_DATATYPE",SRBMetaDataSet.METHOD_DIRECTORY_NAME_FOR_DATATYPE},
								{"METHOD_DIRECTORY_NAME_FOR_DIRECTORY",SRBMetaDataSet.METHOD_DIRECTORY_NAME_FOR_DIRECTORY},
								{"IX_DATATYPE_FOR_FILE",SRBMetaDataSet.IX_DATATYPE_FOR_FILE},
								{"IX_DATATYPE_FOR_DATATYPE",SRBMetaDataSet.IX_DATATYPE_FOR_DATATYPE},
								{"IX_DATATYPE_FOR_DIRECTORY",SRBMetaDataSet.IX_DATATYPE_FOR_DIRECTORY},
								{"METHOD_DATATYPE_FOR_FILE",SRBMetaDataSet.METHOD_DATATYPE_FOR_FILE},
								{"METHOD_DATATYPE_FOR_DATATYPE",SRBMetaDataSet.METHOD_DATATYPE_FOR_DATATYPE},
								{"METHOD_DATATYPE_FOR_DIRECTORY",SRBMetaDataSet.METHOD_DATATYPE_FOR_DIRECTORY},
								{"STRUCTURED_METADATA_DIRECTORY_NAME",SRBMetaDataSet.STRUCTURED_METADATA_DIRECTORY_NAME},
								{"IX_LOCATION_FOR_FILE",SRBMetaDataSet.IX_LOCATION_FOR_FILE},
								{"IX_LOCATION_FOR_DATATYPE",SRBMetaDataSet.IX_LOCATION_FOR_DATATYPE},
								{"IX_LOCATION_FOR_DIRECTORY",SRBMetaDataSet.IX_LOCATION_FOR_DIRECTORY},
								{"METADATA_NUM",SRBMetaDataSet.METADATA_NUM},
								{"DEFINABLE_METADATA_FOR_FILES0",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES0},
								{"DEFINABLE_METADATA_FOR_FILES1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES1},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"DEFINABLE_METADATA_FOR_FILES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES},
								{"INTEGER_DEFINABLE_METADATA0",SRBMetaDataSet.INTEGER_DEFINABLE_METADATA0},
								{"INTEGER_DEFINABLE_METADATA1",SRBMetaDataSet.INTEGER_DEFINABLE_METADATA1},
								{"OWNER_EMAIL",SRBMetaDataSet.OWNER_EMAIL},
								{"AUDIT_USER",SRBMetaDataSet.AUDIT_USER},
								{"AUDIT_USER_DOMAIN",SRBMetaDataSet.AUDIT_USER_DOMAIN},
								{"CONTAINER_FOR_DIRECTORY",SRBMetaDataSet.CONTAINER_FOR_DIRECTORY},
								{"METADATA_NUM_DIRECTORY",SRBMetaDataSet.METADATA_NUM_DIRECTORY},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES0",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES0},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES1},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES},
								{"INTEGER_DEFINABLE_METADATA_FOR_DIRECTORIES0",SRBMetaDataSet.INTEGER_DEFINABLE_METADATA_FOR_DIRECTORIES0},
								{"INTEGER_DEFINABLE_METADATA_FOR_DIRECTORIES1",SRBMetaDataSet.INTEGER_DEFINABLE_METADATA_FOR_DIRECTORIES1},
								{"FILE_ACCESS_ID",SRBMetaDataSet.FILE_ACCESS_ID},
								{"USER_ID",SRBMetaDataSet.USER_ID},
								{"FILE_LAST_ACCESS_TIMESTAMP",SRBMetaDataSet.FILE_LAST_ACCESS_TIMESTAMP},
								{"DIRECTORY_OWNER_NAME",SRBMetaDataSet.DIRECTORY_OWNER_NAME},
								{"DIRECTORY_CREATE_TIMESTAMP",SRBMetaDataSet.DIRECTORY_CREATE_TIMESTAMP},
								{"DIRECTORY_COMMENTS",SRBMetaDataSet.DIRECTORY_COMMENTS},
								{"DC_FILE_NAME",SRBMetaDataSet.DC_FILE_NAME},
								{"DC_DIRECTORY",SRBMetaDataSet.DC_DIRECTORY},
								{"DC_CONTRIBUTOR_TYPE",SRBMetaDataSet.DC_CONTRIBUTOR_TYPE},
								{"DC_SUBJECT_CLASS",SRBMetaDataSet.DC_SUBJECT_CLASS},
								{"DC_DESCRIPTION_TYPE",SRBMetaDataSet.DC_DESCRIPTION_TYPE},
								{"DC_TYPE",SRBMetaDataSet.DC_TYPE},
								{"DC_SOURCE_TYPE",SRBMetaDataSet.DC_SOURCE_TYPE},
								{"DC_LANGUAGE",SRBMetaDataSet.DC_LANGUAGE},
								{"DC_RELATION_TYPE",SRBMetaDataSet.DC_RELATION_TYPE},
								{"DC_COVERAGE_TYPE",SRBMetaDataSet.DC_COVERAGE_TYPE},
								{"DC_RIGHTS_TYPE",SRBMetaDataSet.DC_RIGHTS_TYPE},
								{"DC_TITLE",SRBMetaDataSet.DC_TITLE},
								{"DC_CONTRIBUTOR_NAME",SRBMetaDataSet.DC_CONTRIBUTOR_NAME},
								{"DC_SUBJECT_NAME",SRBMetaDataSet.DC_SUBJECT_NAME},
								{"DC_DESCRIPTION",SRBMetaDataSet.DC_DESCRIPTION},
								{"DC_PUBLISHER",SRBMetaDataSet.DC_PUBLISHER},
								{"DC_SOURCE",SRBMetaDataSet.DC_SOURCE},
								{"DC_RELATED_FILE_DESCRIPTION",SRBMetaDataSet.DC_RELATED_FILE_DESCRIPTION},
								{"DC_RELATED_DATA",SRBMetaDataSet.DC_RELATED_DATA},
								{"DC_RELATED_DIRECTORY",SRBMetaDataSet.DC_RELATED_DIRECTORY},
								{"DC_COVERAGE",SRBMetaDataSet.DC_COVERAGE},
								{"DC_RIGHTS",SRBMetaDataSet.DC_RIGHTS},
								{"DC_PUBLISHER_ADDR",SRBMetaDataSet.DC_PUBLISHER_ADDR},
								{"DC_CONTRIBUTOR_ADDR",SRBMetaDataSet.DC_CONTRIBUTOR_ADDR},
								{"DC_CONTRIBUTOR_EMAIL",SRBMetaDataSet.DC_CONTRIBUTOR_EMAIL},
								{"DC_CONTRIBUTOR_PHONE",SRBMetaDataSet.DC_CONTRIBUTOR_PHONE},
								{"DC_CONTRIBUTOR_WEB",SRBMetaDataSet.DC_CONTRIBUTOR_WEB},
								{"DC_CONTRIBUTOR_AFFILIATION",SRBMetaDataSet.DC_CONTRIBUTOR_AFFILIATION},
								{"COLL_ACCS_ID",SRBMetaDataSet.COLL_ACCS_ID},
								{"COLL_ACCS_USER_ID",SRBMetaDataSet.COLL_ACCS_USER_ID},
								{"DATA_ACCS_ID",SRBMetaDataSet.DATA_ACCS_ID},
								{"DATA_ACCS_USER_ID",SRBMetaDataSet.DATA_ACCS_USER_ID},
								/*		  
								  cannot be accessed from outside package
								{"DEFINABLE_METADATA_FOR_FILES0_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES0_1},
								{"DEFINABLE_METADATA_FOR_FILES0_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES0_2},
								{"DEFINABLE_METADATA_FOR_FILES0_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES0_3},
								{"DEFINABLE_METADATA_FOR_FILES0_4",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES0_4},
								{"DEFINABLE_METADATA_FOR_FILES1_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES1_1},
								{"DEFINABLE_METADATA_FOR_FILES1_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES1_2},
								{"DEFINABLE_METADATA_FOR_FILES1_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES1_3},
								{"DEFINABLE_METADATA_FOR_FILES1_4",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES1_4},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES0_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES0_1},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES0_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES0_2},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES0_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES0_3},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES0_4",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES0_4},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES1_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES1_1},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES1_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES1_2},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES1_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES1_3},
								{"DEFINABLE_METADATA_FOR_DIRECTORIES1_4",SRBMetaDataSet.DEFINABLE_METADATA_FOR_DIRECTORIES1_4},
								*/
								//{"C_TICKET_RECURSIVE",SRBMetaDataSet.C_TICKET_RECURSIVE},
								/* cannot be accessed from outside package
								{"DEFINABLE_METADATA_FOR_RESOURCES0_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES0_1},
								{"DEFINABLE_METADATA_FOR_RESOURCES0_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES0_2},
								{"DEFINABLE_METADATA_FOR_RESOURCES0_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES0_3},
								{"DEFINABLE_METADATA_FOR_RESOURCES1_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES1_1},
								{"DEFINABLE_METADATA_FOR_RESOURCES1_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES1_2},
								{"DEFINABLE_METADATA_FOR_RESOURCES1_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES1_3},
								{"DEFINABLE_METADATA_FOR_USERS0_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS0_1},
								{"DEFINABLE_METADATA_FOR_USERS0_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS0_2},
								{"DEFINABLE_METADATA_FOR_USERS0_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS0_3},
								{"DEFINABLE_METADATA_FOR_USERS1_1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS1_1},
								{"DEFINABLE_METADATA_FOR_USERS1_2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS1_2},
								{"DEFINABLE_METADATA_FOR_USERS1_3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS1_3},
								*/
								{"TAPE_NUMBER",SRBMetaDataSet.TAPE_NUMBER},
								{"TAPE_OWNER",SRBMetaDataSet.TAPE_OWNER},
								{"TAPE_TYPE_VAL",SRBMetaDataSet.TAPE_TYPE_VAL},
								{"TAPE_LIBINX",SRBMetaDataSet.TAPE_LIBINX},
								{"TAPE_FULLFLAG",SRBMetaDataSet.TAPE_FULLFLAG},
								{"TAPE_CURRENT_FILE_SEQNUM",SRBMetaDataSet.TAPE_CURRENT_FILE_SEQNUM},
								{"TAPE_CURRENT_ABS_POSITION",SRBMetaDataSet.TAPE_CURRENT_ABS_POSITION},
								{"TAPE_BYTES_WRITTEN",SRBMetaDataSet.TAPE_BYTES_WRITTEN},
								{"FILE_VER_NUM",SRBMetaDataSet.FILE_VER_NUM},
								{"FILE_LOCK_NUM",SRBMetaDataSet.FILE_LOCK_NUM},
								{"FILE_LOCK_DESCRIPTION",SRBMetaDataSet.FILE_LOCK_DESCRIPTION},
								{"FILE_LOCK_OWNER_NAME",SRBMetaDataSet.FILE_LOCK_OWNER_NAME},
								{"FILE_LOCK_OWNER_DOMAIN",SRBMetaDataSet.FILE_LOCK_OWNER_DOMAIN},
								{"DIRECTORY_OWNER_DOMAIN",SRBMetaDataSet.DIRECTORY_OWNER_DOMAIN},
								//{"C_TICKET_DIRECTORY_NAME",SRBMetaDataSet.C_TICKET_DIRECTORY_NAME},
								//{"C_TICKET_DIRECTORY_CREATE_TIMESTAMP",SRBMetaDataSet.C_TICKET_DIRECTORY_CREATE_TIMESTAMP},
								//{"C_TICKET_DIRECTORY_COMMENTS",SRBMetaDataSet.C_TICKET_DIRECTORY_COMMENTS},
								{"DIRECTORY_ANNOTATION_USERNAME",SRBMetaDataSet.DIRECTORY_ANNOTATION_USERNAME},
								{"DIRECTORY_ANNOTATION_USERDOMAIN",SRBMetaDataSet.DIRECTORY_ANNOTATION_USERDOMAIN},
								{"DIRECTORY_ANNOTATION",SRBMetaDataSet.DIRECTORY_ANNOTATION},
								{"DIRECTORY_ANNOTATION_TIMESTAMP",SRBMetaDataSet.DIRECTORY_ANNOTATION_TIMESTAMP},
								{"DIRECTORY_ANNOTATION_TYPE",SRBMetaDataSet.DIRECTORY_ANNOTATION_TYPE},
								{"FILE_GROUP_ID",SRBMetaDataSet.FILE_GROUP_ID},
								{"FILE_HIDE",SRBMetaDataSet.FILE_HIDE},
								{"FILE_CHECKSUM",SRBMetaDataSet.FILE_CHECKSUM},
								{"FILE_AUDITFLAG",SRBMetaDataSet.FILE_AUDITFLAG},
								{"FILE_LOCK_EXPIRY",SRBMetaDataSet.FILE_LOCK_EXPIRY},
								{"FILE_PIN_VAL",SRBMetaDataSet.FILE_PIN_VAL},
								{"FILE_PIN_OWNER_NAME",SRBMetaDataSet.FILE_PIN_OWNER_NAME},
								{"FILE_PIN_OWNER_DOMAIN",SRBMetaDataSet.FILE_PIN_OWNER_DOMAIN},
								{"FILE_PIN_EXPIRY",SRBMetaDataSet.FILE_PIN_EXPIRY},
								{"FILE_EXPIRY_DATE",SRBMetaDataSet.FILE_EXPIRY_DATE},
								{"FILE_IS_COMPRESSED",SRBMetaDataSet.FILE_IS_COMPRESSED},
								{"FILE_IS_ENCRYPTED",SRBMetaDataSet.FILE_IS_ENCRYPTED},
								{"FILE_EXPIRE_DATE_2",SRBMetaDataSet.FILE_EXPIRE_DATE_2},
								{"NEW_AUDIT_ACTION_DESCRIPTION",SRBMetaDataSet.NEW_AUDIT_ACTION_DESCRIPTION},
								{"NEW_AUDIT_TIMESTAMP",SRBMetaDataSet.NEW_AUDIT_TIMESTAMP},
								{"NEW_AUDIT_COMMENTS",SRBMetaDataSet.NEW_AUDIT_COMMENTS},
								{"DEFINABLE_METADATA_FOR_RESOURCES0",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES0},
								{"DEFINABLE_METADATA_FOR_RESOURCES1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES1},
								{"DEFINABLE_METADATA_FOR_RESOURCES2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES2},
								{"DEFINABLE_METADATA_FOR_RESOURCES3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES3},
								{"DEFINABLE_METADATA_FOR_RESOURCES4",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES4},
								{"DEFINABLE_METADATA_FOR_RESOURCES5",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES5},
								{"DEFINABLE_METADATA_FOR_RESOURCES6",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES6},
								{"DEFINABLE_METADATA_FOR_RESOURCES7",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES7},
								{"DEFINABLE_METADATA_FOR_RESOURCES8",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES8},
								{"DEFINABLE_METADATA_FOR_RESOURCES9",SRBMetaDataSet.DEFINABLE_METADATA_FOR_RESOURCES9},
								{"DEFINABLE_INTEGER_METADATA_RESOURCE0",SRBMetaDataSet.DEFINABLE_INTEGER_METADATA_RESOURCE0},
								{"METADATA_NUM_RESOURCE",SRBMetaDataSet.METADATA_NUM_RESOURCE},
								{"METADATA_NUM_USER",SRBMetaDataSet.METADATA_NUM_USER},
								{"COMPOUND_RESOURCE_NAME",SRBMetaDataSet.COMPOUND_RESOURCE_NAME},
								{"FILE_SEG_NUM",SRBMetaDataSet.FILE_SEG_NUM},
								{"INT_REPLICATION_ENUM",SRBMetaDataSet.INT_REPLICATION_ENUM},
								{"INT_SEG_NUM",SRBMetaDataSet.INT_SEG_NUM},
								{"INT_PATH_NAME",SRBMetaDataSet.INT_PATH_NAME},
								{"INT_RESOURCE_NAME",SRBMetaDataSet.INT_RESOURCE_NAME},
								{"INT_RESOURCE_ADDRESS_NETPREFIX",SRBMetaDataSet.INT_RESOURCE_ADDRESS_NETPREFIX},
								{"INT_RESOURCE_TYPE_NAME",SRBMetaDataSet.INT_RESOURCE_TYPE_NAME},
								{"INT_IS_DIRTY",SRBMetaDataSet.INT_IS_DIRTY},
								{"INT_RESOURCE_CLASS",SRBMetaDataSet.INT_RESOURCE_CLASS},
								{"INT_OFFSET",SRBMetaDataSet.INT_OFFSET},
								{"INT_SIZE",SRBMetaDataSet.INT_SIZE},
								{"COMP_OBJ_USER_NAME",SRBMetaDataSet.COMP_OBJ_USER_NAME},
								{"COMP_OBJ_USER_DOMAIN",SRBMetaDataSet.COMP_OBJ_USER_DOMAIN},
								{"INT_PATH_NAME_FOR_REPL",SRBMetaDataSet.INT_PATH_NAME_FOR_REPL},
								{"DIRECTORY_LINK_NUM",SRBMetaDataSet.DIRECTORY_LINK_NUM},
								{"REAL_DIRECTORY_NAME",SRBMetaDataSet.REAL_DIRECTORY_NAME},
								{"FILE_CONTAINER_NAME",SRBMetaDataSet.FILE_CONTAINER_NAME},
								{"DIRECTORY_CONTAINER_NAME",SRBMetaDataSet.DIRECTORY_CONTAINER_NAME},
								{"DEFINABLE_METADATA_FOR_USERS0",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS0},
								{"DEFINABLE_METADATA_FOR_USERS1",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS1},
								{"DEFINABLE_METADATA_FOR_USERS2",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS2},
								{"DEFINABLE_METADATA_FOR_USERS3",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS3},
								{"DEFINABLE_METADATA_FOR_USERS4",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS4},
								{"DEFINABLE_METADATA_FOR_USERS5",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS5},
								{"DEFINABLE_METADATA_FOR_USERS6",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS6},
								{"DEFINABLE_METADATA_FOR_USERS7",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS7},
								{"DEFINABLE_METADATA_FOR_USERS8",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS8},
								{"DEFINABLE_METADATA_FOR_USERS9",SRBMetaDataSet.DEFINABLE_METADATA_FOR_USERS9},
								{"UDIMD_USER0",SRBMetaDataSet.UDIMD_USER0},
								{"NONDISTINCT",SRBMetaDataSet.NONDISTINCT},
								{"USERDEFFUNC01",SRBMetaDataSet.USERDEFFUNC01},
								{"USERDEFFUNC02",SRBMetaDataSet.USERDEFFUNC02},
								{"USERDEFFUNC03",SRBMetaDataSet.USERDEFFUNC03},
								{"USERDEFFUNC04",SRBMetaDataSet.USERDEFFUNC04},
								{"USERDEFFUNC05",SRBMetaDataSet.USERDEFFUNC05},
							
								// For Retrieving User Defined Attribute Names
								{"USER_DEFINED_ATTRIBUTES_NAMES",SRBMetaDataSet.DEFINABLE_METADATA_FOR_FILES0},						
							
							
							};	
							
							
	public static String mapMatrixVariableToSRBVariable(String variable)
		{
			MatrixUtil.toLog("SRBMetaDataFieldMappings-mapMatrixVariableToSRBVariable():BEGIN", 5);
			String srbVariableName = null;
			MatrixUtil.toLog("SRBMetaDataFieldMappings - mapMatrixVariableToSRBVariable() - variable:"+variable,0);
	
			for(int variableIndex=0;variableIndex<srbVariableMapping.length;variableIndex++)
			{
				if(srbVariableMapping[variableIndex][0].equals(variable))
				{
					srbVariableName = 	srbVariableMapping[variableIndex][1];					
					break;	
				}
			}		
		
			
			MatrixUtil.toLog("SRBMetaDataFieldMappings - mapMatrixVariableToSRBVariable() - srbVariableName:"+srbVariableName,0);
			MatrixUtil.toLog("SRBMetaDataFieldMappings-mapMatrixVariableToSRBVariable():END", 5);
			return 	srbVariableName;
		}							
	
}	

