/**************************************************************************
Copyright Notice
All Rights Reserved
Please refer to files in COPYRIGHT directory under the SRB software directory 
for copyright, usage, liability and license information.
Please read these files before using,modifying or distributing SRB software.
**************************************************************************/
 


#include "scommands.h"

 
extern char srbAuth[];
extern char srbHost[];
extern char mdasCollectionName[];
extern char mdasCollectionHome[];
extern char inCondition[];

 srbConn *conn;
 int   copyNum = -1;

int
phymove_srbobjs(char srbobjs[][MAX_OBJ_NAME_LENGTH], char *newresourcename, 
		char * pathname,  int pval, int  lcount)
{
  char newpathname[MAX_TOKEN];
  char tmpStr[MAX_TOKEN];
  char collname[MAX_TOKEN];
  char dataname[MAX_TOKEN];
  int i,j;
  char inbuf[100];

  strcpy(newpathname,"");

  for (i = 1; i < lcount ; i++)
    {
      splitpath(srbobjs[i],collname,dataname);
      if (strlen(pathname) > 0)
        {
	  if (lcount == 2)
	    strcpy(newpathname, pathname);
	  else
	    sprintf(newpathname, "%s/%s", pathname, dataname);
	}
      if (pval == 1)
	{
	  if (copyNum < 0)
	    fprintf(stdout,"Move  %s  to %s (y/n)?",
		    srbobjs[i],newresourcename);
	  else
	    fprintf(stdout,"Move  %s&COPY=%i  to %s (y/n)?",
		    srbobjs[i],copyNum ,newresourcename);
	  fgets(inbuf, 100, stdin);
	   if (inbuf[0] != 'y' )
              continue;

	}
      if (copyNum >=  0)
	{
	  sprintf(tmpStr, "&COPY=%i",copyNum);
            strcat(dataname,tmpStr);
	}

      j = srbObjMove(conn, MDAS_CATALOG, dataname, collname,
			  newresourcename, newpathname);
	    if (j < 0)  
	      {   /* error */
		fprintf(stdout, "Sphymove: move error for %s :%i\n",
			srbobjs[i],j);
		srb_perror (2, j, "", SRB_RCMD_ACTION|SRB_LONG_MSG);
	      }
    }
    return (j);
 
}


void usage()
{
fprintf(stderr, 
           "Usage: Sphymove [-C n] [-p] [-P pathName] srbObj ... NewResource\n");
}
int
main(int argc, char **argv)
{
    srbResult *res;
    int pval, mval, lcount;

    char *srbobjs[MAX_TOKEN];

    char buf[BUFSIZE];
    int i;
    char collname[MAX_TOKEN];
    char dataname[MAX_TOKEN];
    char filename[MAX_TOKEN];
    int  newargc;
    char newargv[MAX_ARG_EXP_CNT/6][MAX_OBJ_NAME_LENGTH];
    char resourcename[MAX_TOKEN];
    char pathname[MAX_TOKEN];
    char newresourcename[MAX_TOKEN];
    char newpathname[MAX_TOKEN];
    int  datasize;

   pval = 0;
   mval = 1;
   strcpy(pathname,"");
   strcpy(inCondition , "");

   if (argc < 3) {usage(); exit(1);}

    while (argv[mval][0] == '-')
      {if (argv[mval][1] == 'p')
        { pval = 1; mval++;}
      else if(argv[mval][1] == 'P') 
        { if (argc < mval+2) {usage(); exit(1);}
	  strcpy(pathname, argv[++mval]); mval++;}
      else if(argv[mval][1] == 'C') 
        {if (argc < mval+2) {usage(); exit(1);}
	  copyNum = atoi(argv[++mval]); mval++;}
      else
         {fprintf(stderr, "Unknown Option\n");
          fprintf(stderr, 
           "Usage: Sphymove [-C n] [-p] [-P pathName] srbObj ... NewResource\n");
         exit(1);
         }
      }
 
    if (argc < mval+2) 
      {fprintf(stderr, 
	 "Usage: Sphymove  [-C n] [-p] [-P pathName] srbObj ... NewResource\n");
      exit(1);
      }
    strcpy(newresourcename, argv[argc-1]);

    i = initSrbClientEnv();
    if (i < 0)
      {printf("Sphymove: Initialization Error:%i\n",i); exit(1);}

    conn = srbConnect (srbHost, NULL, srbAuth, 
     NULL, NULL, NULL, NULL);
    if (clStatus(conn) != CLI_CONNECTION_OK) {
        fprintf(stderr,"Sphymov: Connection to srbMaster failed.\n");
        fprintf(stderr,"Sphymov: %s",clErrorMessage(conn));
	srb_perror (2, clStatus(conn), "", SRB_RCMD_ACTION|SRB_LONG_MSG);
	clFinish(conn); exit(3);
    }
    expand_file_names(conn, mval, argc-1, argv, &newargc,newargv);

    phymove_srbobjs(newargv, newresourcename, pathname,pval, newargc); 
    clFinish(conn);
    exit(0);
}
